diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicPumpkinRedstone.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPumpkinRedstone.java
index d1dc9dd51..67112f100 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicPumpkinRedstone.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPumpkinRedstone.java
@@ -1,40 +1,44 @@
 package net.minecraft.core.block;
 
 import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 
 public class BlockLogicPumpkinRedstone extends BlockLogicVeryRotatable {
 
     public BlockLogicPumpkinRedstone(@NotNull Block<?> block) {
-        super(block, Material.vegetable);
+        super(block, Materials.VEGETABLE);
     }
 
     @Override
-    public void onPlacedByWorld(@NotNull World world, @NotNull TilePos tilePos) {
+    public void onPlacedByWorld(@NotNull World world, @NotNull TilePosc tilePos) {
+        TilePos queryPos = new TilePos();
         for (Direction dir : Direction.directions){
-            world.notifyBlocksOfNeighborChange(tilePos.add(dir), id());
+            world.notifyBlocksOfNeighborChange(tilePos.add(dir, queryPos), id());
         }
     }
 
     @Override
-    public void onRemoved(@NotNull World world, @NotNull TilePos tilePos, int data) {
+    public void onRemoved(@NotNull World world, @NotNull TilePosc tilePos, int data) {
+        TilePos queryPos = new TilePos();
         for (Direction dir : Direction.directions){
-            world.notifyBlocksOfNeighborChange(tilePos.add(dir), id());
+            world.notifyBlocksOfNeighborChange(tilePos.add(dir, queryPos), id());
         }
     }
 
     @Override
-    public boolean isEmittingDirectSignal(@NotNull World world, @NotNull TilePos tilePos, @NotNull Side side) {
+    public boolean isEmittingDirectSignal(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side) {
         return isEmittingSignal(world, tilePos, side);
     }
 
     @Override
-    public boolean isEmittingSignal(@NotNull WorldSource source, @NotNull TilePos tilePos, @NotNull Side side) {
+    public boolean isEmittingSignal(@NotNull WorldSource source, @NotNull TilePosc tilePos, @NotNull Side side) {
         Side mySide = Side.getSideById(source.getBlockData(tilePos));
         return mySide == side.getOpposite();
     }
@@ -45,7 +49,7 @@ public class BlockLogicPumpkinRedstone extends BlockLogicVeryRotatable {
     }
 
     @Override
-    public int getPistonPushReaction(@NotNull World world, @NotNull TilePos tilePos) {
+    public int getPistonPushReaction(@NotNull World world, @NotNull TilePosc tilePos) {
         return Material.PISTON_PUSHABLE;
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRail.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRail.java
index ffe956de2..6f48849b8 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRail.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRail.java
@@ -2,6 +2,7 @@ package net.minecraft.core.block;
 
 import net.minecraft.core.block.logic.RailDirection;
 import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.block.support.FullSupport;
 import net.minecraft.core.block.support.ISupport;
 import net.minecraft.core.block.support.ISupportable;
@@ -9,12 +10,14 @@ import net.minecraft.core.block.support.PartialSupport;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.util.helper.Axis;
 import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.primitives.AABBd;
+import org.joml.primitives.AABBdc;
 
 import java.util.ArrayList;
 import java.util.List;
@@ -29,14 +32,14 @@ public class BlockLogicRail extends BlockLogic implements ISupportable {
     }
 
     protected BlockLogicRail(@NotNull Block<?> block, boolean isPowered) {
-        super(block, Material.decoration);
+        super(block, Materials.DECORATION);
         this.isPowered = isPowered;
         setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 0.125F, 1.0F);
     }
 
-    public @NotNull RailDirection getRailDirection(@NotNull WorldSource world, @NotNull TilePos tilePos){
+    public @NotNull RailDirection getRailDirection(@NotNull WorldSource world, @NotNull TilePosc tilePos) {
         int meta = world.getBlockData(tilePos);
-        if (this.isPowered){
+        if (this.isPowered) {
             meta &= MASK_DIRECTION;
         }
         return RailDirection.getFromMeta(meta);
@@ -47,59 +50,58 @@ public class BlockLogicRail extends BlockLogic implements ISupportable {
     }
 
     @Override
-    public @Nullable AABB getCollisionAABB(@NotNull WorldSource source, @NotNull TilePos tilePos) {
+    public @Nullable AABBdc getCollisionAABB(@NotNull WorldSource source, @NotNull TilePosc tilePos) {
         return null;
     }
 
     @Override
-	public boolean isSolidRender()
-    {
+    public boolean isSolidRender() {
         return false;
     }
 
     @Override
-    public @NotNull AABB getBoundsFromState(@NotNull WorldSource source, @NotNull TilePos tilePos) {
+    public @NotNull AABBdc getBoundsFromState(@NotNull WorldSource source, @NotNull TilePosc tilePos) {
         RailDirection direction = getRailDirection(source, tilePos);
-        if(direction.isSloped()) {
-            return AABB.fromPool(0.0F, 0.0F, 0.0F, 1.0F, 0.725F, 1.0F);
+        if (direction.isSloped()) {
+            return new AABBd(0.0F, 0.0F, 0.0F, 1.0F, 0.725F, 1.0F);
         } else {
-            return AABB.fromPool(0.0F, 0.0F, 0.0F, 1.0F, 0.125F, 1.0F);
+            return new AABBd(0.0F, 0.0F, 0.0F, 1.0F, 0.125F, 1.0F);
         }
     }
 
     @Override
-	public boolean isCubeShaped()
-    {
+    public boolean isCubeShaped() {
         return false;
     }
 
     @Override
-    public @NotNull ISupport getSupport(@NotNull World world, @NotNull TilePos tilePos, @NotNull Side side) {
+    public @NotNull ISupport getSupport(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side) {
         return PartialSupport.INSTANCE;
     }
 
     @Override
-	public boolean canPlaceAt(@NotNull World world, @NotNull TilePos tilePos) {
+    public boolean canPlaceAt(@NotNull World world, @NotNull TilePosc tilePos) {
         return isSupported(world, tilePos, Side.BOTTOM);
     }
 
     @Override
-	public void onPlacedByWorld(@NotNull World world, @NotNull TilePos tilePos) {
+    public void onPlacedByWorld(@NotNull World world, @NotNull TilePosc tilePos) {
         performRailTurn(world, tilePos, true);
-        if(this.block == Blocks.RAIL_POWERED) {
-        	onNeighborChanged(world, tilePos, id());
+        if (this.block == Blocks.RAIL_POWERED) {
+            onNeighborChanged(world, tilePos, id());
         }
     }
+
     @Override
-	public void onNeighborChanged(@NotNull World world, @NotNull TilePos tilePos, int id) {
-        if(world.isClientSide) {
+    public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, int id) {
+        if (world.isClientSide) {
             return;
         }
         int meta = world.getBlockData(tilePos);
         boolean isPoweredFlagSet = (meta & MASK_POWERED) != 0;
         RailDirection railDirection = getRailDirection(world, tilePos);
 
-        if(!isSupported(world, tilePos, Side.BOTTOM)) {
+        if (!isSupported(world, tilePos, Side.BOTTOM)) {
             dropWithCause(world, EnumDropCause.WORLD, tilePos, world.getBlockData(tilePos), null, null);
             world.setBlockIdNotify(tilePos, 0);
             return;
@@ -122,97 +124,102 @@ public class BlockLogicRail extends BlockLogic implements ISupportable {
 
         Block<?> block = Blocks.getBlock(id);
 
-        if(this.block == Blocks.RAIL_POWERED) {
+        if (this.block == Blocks.RAIL_POWERED) {
+            TilePos queryPos = new TilePos();
+
             boolean gettingPower =
-                    world.hasNeighborSignal(tilePos) ||
-                    world.hasNeighborSignal(tilePos.up()) ||
+                world.hasNeighborSignal(tilePos) ||
+                    world.hasNeighborSignal(tilePos.up(queryPos)) ||
                     isConnectedPoweredRail1(world, tilePos, true, 0) ||
                     isConnectedPoweredRail1(world, tilePos, false, 0);
 
             boolean changedMeta = false;
-            if(gettingPower && !isPoweredFlagSet) {
+            if (gettingPower && !isPoweredFlagSet) {
                 // Set powered bit
                 world.setBlockDataNotify(tilePos, railDirection.meta | MASK_POWERED);
                 changedMeta = true;
-            } else if(!gettingPower && isPoweredFlagSet) {
+            } else if (!gettingPower && isPoweredFlagSet) {
                 // Remove powered bit
                 world.setBlockDataNotify(tilePos, railDirection.meta);
                 changedMeta = true;
             }
 
-            if(changedMeta) {
-                world.notifyBlocksOfNeighborChange(tilePos.down(), id());
-                if(railDirection.isSloped()) {
-                    world.notifyBlocksOfNeighborChange(tilePos.up(), id());
+            if (changedMeta) {
+                world.notifyBlocksOfNeighborChange(tilePos.down(queryPos), id());
+                if (railDirection.isSloped()) {
+                    world.notifyBlocksOfNeighborChange(tilePos.up(queryPos), id());
                 }
             }
-        } else if(block != null && block.isSignalSource() && new Rail(world, tilePos).getAdjacentTracks()== 3) {
+        } else if (block != null && block.isSignalSource() && new Rail(world, tilePos).getAdjacentTracks() == 3) {
             performRailTurn(world, tilePos, false);
         }
     }
     // Checks that the rail is placed on top of a block and doesn't slope into the air
 
-    private boolean isRailValid(@NotNull World world, @NotNull TilePos tilePos){
+    private boolean isRailValid(@NotNull World world, @NotNull TilePosc tilePos) {
+        TilePos queryPos = new TilePos();
         return switch (getRailDirection(world, tilePos)) {
-            case SLOPE_E -> isSupported(world, tilePos.add(1, 1, 0), Side.BOTTOM);
-            case SLOPE_W -> isSupported(world, tilePos.add(-1, 1, 0), Side.BOTTOM);
-            case SLOPE_N -> isSupported(world, tilePos.add(0, 1, -1), Side.BOTTOM);
-            case SLOPE_S -> isSupported(world, tilePos.add(0, 1, 1), Side.BOTTOM);
+            case SLOPE_E -> isSupported(world, tilePos.add(1, 1, 0, queryPos), Side.BOTTOM);
+            case SLOPE_W -> isSupported(world, tilePos.add(-1, 1, 0, queryPos), Side.BOTTOM);
+            case SLOPE_N -> isSupported(world, tilePos.add(0, 1, -1, queryPos), Side.BOTTOM);
+            case SLOPE_S -> isSupported(world, tilePos.add(0, 1, 1, queryPos), Side.BOTTOM);
             default -> true;
         };
     }
     // Turn logic what a regular rail is powered in an intersection
 
-    private void performRailTurn(@NotNull World world, @NotNull TilePos tilePos, boolean forceUpdate) {
+    private void performRailTurn(@NotNull World world, @NotNull TilePosc tilePos, boolean forceUpdate) {
         if (!world.isClientSide) {
             new Rail(world, tilePos).railTurn(world.hasNeighborSignal(tilePos), forceUpdate);
         }
     }
 
-    private boolean isConnectedPoweredRail1(@NotNull World world, @NotNull TilePos tilePos, boolean forward, int distance) {
+    private boolean isConnectedPoweredRail1(@NotNull World world, @NotNull TilePosc tilePos, boolean forward, int distance) {
         // Only check for powered rails for an 8 block span
-        if(distance >= 8) {
+        if (distance >= 8) {
             return false;
         }
         RailDirection railDirection = getRailDirection(world, tilePos);
         Axis axis = Axis.NONE;
 
 
-        TilePos next = forward ? railDirection.getNextRail(tilePos) : railDirection.getPrevRail(tilePos);
+        TilePos next = forward ? railDirection.getNextRail(tilePos, new TilePos()) : railDirection.getPrevRail(tilePos, new TilePos());
         axis = switch (railDirection) {
             case STRAIGHT_NS, SLOPE_N, SLOPE_S -> Axis.Z;
             case STRAIGHT_EW, SLOPE_E, SLOPE_W -> Axis.X;
             default -> axis;
         };
 
-        if(isConnectedPoweredRail2(world, next, forward, distance, axis)) { return true; }
-        return isConnectedPoweredRail2(world, next.down(), forward, distance, axis);
+        if (isConnectedPoweredRail2(world, next, forward, distance, axis)) {
+            return true;
+        }
+        return isConnectedPoweredRail2(world, next.down(new TilePos()), forward, distance, axis);
     }
 
     private boolean isConnectedPoweredRail2(@NotNull World world, @NotNull TilePos tilePos, boolean forward, int distance, @NotNull Axis axis) {
         int blockId = world.getBlockId(tilePos);
-        if(blockId == Blocks.RAIL_POWERED.id()) {
+        if (blockId == Blocks.RAIL_POWERED.id()) {
             int meta = world.getBlockData(tilePos);
             boolean isPoweredFlagSet = (meta & MASK_POWERED) != 0;
             RailDirection direction = getRailDirection(world, tilePos);
 
             // Return false for perpendicular powered rails
-            if(axis == Axis.X && (
-                    direction == RailDirection.STRAIGHT_NS ||
+            if (axis == Axis.X && (
+                direction == RailDirection.STRAIGHT_NS ||
                     direction == RailDirection.SLOPE_N ||
                     direction == RailDirection.SLOPE_S)) {
                 return false;
             }
-            if(axis == Axis.Z && (
-                    direction == RailDirection.STRAIGHT_EW ||
+            if (axis == Axis.Z && (
+                direction == RailDirection.STRAIGHT_EW ||
                     direction == RailDirection.SLOPE_E ||
                     direction == RailDirection.SLOPE_W)) {
                 return false;
             }
 
-            if(isPoweredFlagSet) {
+            if (isPoweredFlagSet) {
                 // If rail powered return true
-                if(world.hasNeighborSignal(tilePos) || world.hasNeighborSignal(tilePos.up())) {
+                if (world.hasNeighborSignal(tilePos) || world.hasNeighborSignal(tilePos.up(new TilePos()))) {
                     return true;
                 } else { // else check 1 block further down if powered
                     return isConnectedPoweredRail1(world, tilePos, forward, distance + 1);
@@ -223,12 +230,12 @@ public class BlockLogicRail extends BlockLogic implements ISupportable {
     }
 
     @Override
-    public int getPistonPushReaction(@NotNull World world, @NotNull TilePos tilePos) {
+    public int getPistonPushReaction(@NotNull World world, @NotNull TilePosc tilePos) {
         return Material.PISTON_PUSHABLE;
     }
 
     @Override
-    public @NotNull ISupport getSupportConstraint(@NotNull World world, @NotNull TilePos tilePos, @NotNull Side side) {
+    public @NotNull ISupport getSupportConstraint(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side) {
         return side == Side.BOTTOM ? FullSupport.INSTANCE : PartialSupport.INSTANCE;
     }
 
@@ -237,9 +244,10 @@ public class BlockLogicRail extends BlockLogic implements ISupportable {
         private final @NotNull TilePos pos;
         private final boolean isPoweredRail;
         private final @NotNull List<TilePos> connectedTracks = new ArrayList<>();
-        public Rail(@NotNull World world, @NotNull TilePos pos) {
+
+        public Rail(@NotNull World world, @NotNull TilePosc pos) {
             this.world = world;
-            this.pos = pos;
+            this.pos = new TilePos(pos);
             BlockLogicRail logicRail = world.getBlockLogic(pos, BlockLogicRail.class);
             this.isPoweredRail = logicRail != null && logicRail.isPowered;
             int meta = world.getBlockData(pos) & (this.isPoweredRail ? MASK_DIRECTION : 0b1111_1111);
@@ -250,14 +258,14 @@ public class BlockLogicRail extends BlockLogic implements ISupportable {
 
         private void setConnections(@NotNull RailDirection direction) {
             this.connectedTracks.clear();
-            this.connectedTracks.add(direction.getNextRail(this.pos));
-            this.connectedTracks.add(direction.getPrevRail(this.pos));
+            this.connectedTracks.add(direction.getNextRail(this.pos, new TilePos()));
+            this.connectedTracks.add(direction.getPrevRail(this.pos, new TilePos()));
         }
 
         private void checkAndRemoveMissingRails() {
-            for(int i = 0; i < this.connectedTracks.size(); i++) {
+            for (int i = 0; i < this.connectedTracks.size(); i++) {
                 Rail rail = getMinecartTrackLogic(this.connectedTracks.get(i));
-                if(rail == null || !rail.isConnectedTo(this)) {
+                if (rail == null || !rail.isConnectedTo(this)) {
                     this.connectedTracks.remove(i--);
                 } else {
                     this.connectedTracks.set(i, rail.pos);
@@ -267,26 +275,26 @@ public class BlockLogicRail extends BlockLogic implements ISupportable {
         }
 
         private boolean isMinecartTrack(@NotNull TilePos tilePos) {
-            if(BlockLogicRail.isRailBlockAt(this.world, tilePos)) {
+            TilePos queryPos = new TilePos();
+            if (BlockLogicRail.isRailBlockAt(this.world, tilePos)) {
                 return true;
             }
-            if(BlockLogicRail.isRailBlockAt(this.world, tilePos.up())) {
+            if (BlockLogicRail.isRailBlockAt(this.world, tilePos.up(queryPos))) {
                 return true;
             }
-            return BlockLogicRail.isRailBlockAt(this.world, tilePos.down());
+            return BlockLogicRail.isRailBlockAt(this.world, tilePos.down(queryPos));
         }
 
         private @Nullable Rail getMinecartTrackLogic(@NotNull TilePos tilePos) {
-            if(BlockLogicRail.isRailBlockAt(this.world, tilePos)) {
+            if (BlockLogicRail.isRailBlockAt(this.world, tilePos)) {
                 return new Rail(this.world, tilePos);
             }
-            TilePos up = tilePos.up();
-            if(BlockLogicRail.isRailBlockAt(this.world, up)) {
-                return new Rail(this.world, up);
+            TilePos queryPos = new TilePos();
+            if (BlockLogicRail.isRailBlockAt(this.world, tilePos.up(queryPos))) {
+                return new Rail(this.world, tilePos.up(queryPos));
             }
-            TilePos down = tilePos.down();
-            if(BlockLogicRail.isRailBlockAt(this.world, down)) {
-                return new Rail(this.world, down);
+            if (BlockLogicRail.isRailBlockAt(this.world, tilePos.down(queryPos))) {
+                return new Rail(this.world, tilePos.down(queryPos));
             }
             return null;
         }
@@ -310,28 +318,30 @@ public class BlockLogicRail extends BlockLogic implements ISupportable {
         }
 
         private int getAdjacentTracks() {
+            TilePos queryPos = new TilePos();
             int count = 0;
-            if(isMinecartTrack(this.pos.north())) {
+            if (isMinecartTrack(this.pos.north(queryPos))) {
                 count++;
             }
-            if(isMinecartTrack(this.pos.south())) {
+            if (isMinecartTrack(this.pos.south(queryPos))) {
                 count++;
             }
-            if(isMinecartTrack(this.pos.west())) {
+            if (isMinecartTrack(this.pos.west(queryPos))) {
                 count++;
             }
-            if(isMinecartTrack(this.pos.east())) {
+            if (isMinecartTrack(this.pos.east(queryPos))) {
                 count++;
             }
             return count;
         }
 
         private boolean handleKeyPress(@NotNull Rail rail) {
-            if(isConnectedTo(rail)) {
+            if (isConnectedTo(rail)) {
                 return true;
             }
             return this.connectedTracks.size() != 2;
         }
+
         private boolean canTrackTurnTo(@NotNull TilePos tilePos) {
             Rail rail = getMinecartTrackLogic(tilePos);
             if (rail == null) return false;
@@ -341,82 +351,83 @@ public class BlockLogicRail extends BlockLogic implements ISupportable {
         }
 
         public void railTurn(boolean isPowered, boolean forceUpdate) {
-            boolean flagNorth = canTrackTurnTo(this.pos.north());
-            boolean flagSouth = canTrackTurnTo(this.pos.south());
-            boolean flagWest = canTrackTurnTo(this.pos.west());
-            boolean flagEast = canTrackTurnTo(this.pos.east());
+            TilePos queryPos = new TilePos();
+            boolean flagNorth = canTrackTurnTo(this.pos.north(queryPos));
+            boolean flagSouth = canTrackTurnTo(this.pos.south(queryPos));
+            boolean flagWest = canTrackTurnTo(this.pos.west(queryPos));
+            boolean flagEast = canTrackTurnTo(this.pos.east(queryPos));
 
             RailDirection railType = RailDirection.NONE;
-            if((flagNorth || flagSouth) && !flagWest && !flagEast) {
+            if ((flagNorth || flagSouth) && !flagWest && !flagEast) {
                 railType = RailDirection.STRAIGHT_NS;
             }
-            if((flagWest || flagEast) && !flagNorth && !flagSouth) {
+            if ((flagWest || flagEast) && !flagNorth && !flagSouth) {
                 railType = RailDirection.STRAIGHT_EW;
             }
-            if(!this.isPoweredRail) {
-                if(flagSouth && flagEast && !flagNorth && !flagWest) {
+            if (!this.isPoweredRail) {
+                if (flagSouth && flagEast && !flagNorth && !flagWest) {
                     railType = RailDirection.TURN_ES;
                 }
-                if(flagSouth && flagWest && !flagNorth && !flagEast) {
+                if (flagSouth && flagWest && !flagNorth && !flagEast) {
                     railType = RailDirection.TURN_WS;
                 }
-                if(flagNorth && flagWest && !flagSouth && !flagEast) {
+                if (flagNorth && flagWest && !flagSouth && !flagEast) {
                     railType = RailDirection.TURN_WN;
                 }
-                if(flagNorth && flagEast && !flagSouth && !flagWest) {
+                if (flagNorth && flagEast && !flagSouth && !flagWest) {
                     railType = RailDirection.TURN_EN;
                 }
             }
-            if(railType == RailDirection.NONE) {
-                if(flagNorth || flagSouth) {
+            if (railType == RailDirection.NONE) {
+                if (flagNorth || flagSouth) {
                     railType = RailDirection.STRAIGHT_NS;
                 }
-                if(flagWest || flagEast) {
+                if (flagWest || flagEast) {
                     railType = RailDirection.STRAIGHT_EW;
                 }
-                if(!this.isPoweredRail) {
-                    if(isPowered) {
-                        if(flagSouth && flagEast) {
+                if (!this.isPoweredRail) {
+                    if (isPowered) {
+                        if (flagSouth && flagEast) {
                             railType = RailDirection.TURN_ES;
                         }
-                        if(flagWest && flagSouth) {
+                        if (flagWest && flagSouth) {
                             railType = RailDirection.TURN_WS;
                         }
-                        if(flagEast && flagNorth) {
+                        if (flagEast && flagNorth) {
                             railType = RailDirection.TURN_EN;
                         }
-                        if(flagNorth && flagWest) {
+                        if (flagNorth && flagWest) {
                             railType = RailDirection.TURN_WN;
                         }
                     } else {
-                        if(flagNorth && flagWest) {
+                        if (flagNorth && flagWest) {
                             railType = RailDirection.TURN_WN;
                         }
-                        if(flagEast && flagNorth) {
+                        if (flagEast && flagNorth) {
                             railType = RailDirection.TURN_EN;
                         }
-                        if(flagWest && flagSouth) {
+                        if (flagWest && flagSouth) {
                             railType = RailDirection.TURN_WS;
                         }
-                        if(flagSouth && flagEast) {
+                        if (flagSouth && flagEast) {
                             railType = RailDirection.TURN_ES;
                         }
                     }
                 }
             }
-            if(railType == RailDirection.STRAIGHT_NS) {
-                if(BlockLogicRail.isRailBlockAt(this.world, this.pos.add(0, 1, -1))) {
+            if (railType == RailDirection.STRAIGHT_NS) {
+                if (BlockLogicRail.isRailBlockAt(this.world, this.pos.add(0, 1, -1, queryPos))) {
                     railType = RailDirection.SLOPE_N;
                 }
-                if(BlockLogicRail.isRailBlockAt(this.world, this.pos.add(0, 1, 1))) {
+                if (BlockLogicRail.isRailBlockAt(this.world, this.pos.add(0, 1, 1, queryPos))) {
                     railType = RailDirection.SLOPE_S;
                 }
             }
-            if(railType == RailDirection.STRAIGHT_EW) {
-                if(BlockLogicRail.isRailBlockAt(this.world, this.pos.add(1, 1, 0))) {
+            if (railType == RailDirection.STRAIGHT_EW) {
+                if (BlockLogicRail.isRailBlockAt(this.world, this.pos.add(1, 1, 0, queryPos))) {
                     railType = RailDirection.SLOPE_E;
                 }
-                if(BlockLogicRail.isRailBlockAt(this.world, this.pos.add(-1, 1, 0))) {
+                if (BlockLogicRail.isRailBlockAt(this.world, this.pos.add(-1, 1, 0, queryPos))) {
                     railType = RailDirection.SLOPE_W;
                 }
             }
@@ -426,11 +437,11 @@ public class BlockLogicRail extends BlockLogic implements ISupportable {
             setConnections(railType);
 
             int newMeta = railType.meta;
-            if(this.isPoweredRail) {
+            if (this.isPoweredRail) {
                 newMeta |= this.world.getBlockData(this.pos) & MASK_POWERED;
             }
 
-            if(forceUpdate || this.world.getBlockData(this.pos) != newMeta) {
+            if (forceUpdate || this.world.getBlockData(this.pos) != newMeta) {
                 this.world.setBlockDataNotify(this.pos, newMeta);
                 // Update the rail states of the connected tracks
                 for (TilePos connectedTrack : this.connectedTracks) {
@@ -445,54 +456,56 @@ public class BlockLogicRail extends BlockLogic implements ISupportable {
                 }
             }
         }
+
         private void updateRailState(@NotNull Rail otherLogic) {
             this.connectedTracks.add(otherLogic.pos);
-            boolean flagNorth = isInTrack(this.pos.north());
-            boolean flagSouth = isInTrack(this.pos.south());
-            boolean flagWest = isInTrack(this.pos.west());
-            boolean flagEast = isInTrack(this.pos.east());
+            TilePos queryPos = new TilePos();
+            boolean flagNorth = isInTrack(this.pos.north(queryPos));
+            boolean flagSouth = isInTrack(this.pos.south(queryPos));
+            boolean flagWest = isInTrack(this.pos.west(queryPos));
+            boolean flagEast = isInTrack(this.pos.east(queryPos));
             RailDirection railDirection = RailDirection.NONE;
-            if(flagNorth || flagSouth) {
+            if (flagNorth || flagSouth) {
                 railDirection = RailDirection.STRAIGHT_NS;
             }
-            if(flagWest || flagEast) {
+            if (flagWest || flagEast) {
                 railDirection = RailDirection.STRAIGHT_EW;
             }
-            if(!this.isPoweredRail) {
-                if(flagSouth && flagEast && !flagNorth && !flagWest) {
+            if (!this.isPoweredRail) {
+                if (flagSouth && flagEast && !flagNorth && !flagWest) {
                     railDirection = RailDirection.TURN_ES;
                 }
-                if(flagSouth && flagWest && !flagNorth && !flagEast) {
+                if (flagSouth && flagWest && !flagNorth && !flagEast) {
                     railDirection = RailDirection.TURN_WS;
                 }
-                if(flagNorth && flagWest && !flagSouth && !flagEast) {
+                if (flagNorth && flagWest && !flagSouth && !flagEast) {
                     railDirection = RailDirection.TURN_WN;
                 }
-                if(flagNorth && flagEast && !flagSouth && !flagWest) {
+                if (flagNorth && flagEast && !flagSouth && !flagWest) {
                     railDirection = RailDirection.TURN_EN;
                 }
             }
-            if(railDirection == RailDirection.STRAIGHT_NS) {
-                if(BlockLogicRail.isRailBlockAt(this.world, this.pos.add(0, 1, -1))) {
+            if (railDirection == RailDirection.STRAIGHT_NS) {
+                if (BlockLogicRail.isRailBlockAt(this.world, this.pos.add(0, 1, -1, queryPos))) {
                     railDirection = RailDirection.SLOPE_N;
                 }
-                if(BlockLogicRail.isRailBlockAt(this.world, this.pos.add(0, 1, 1))) {
+                if (BlockLogicRail.isRailBlockAt(this.world, this.pos.add(0, 1, 1, queryPos))) {
                     railDirection = RailDirection.SLOPE_S;
                 }
             }
-            if(railDirection == RailDirection.STRAIGHT_EW) {
-                if(BlockLogicRail.isRailBlockAt(this.world, this.pos.add(1, 1, 0))) {
+            if (railDirection == RailDirection.STRAIGHT_EW) {
+                if (BlockLogicRail.isRailBlockAt(this.world, this.pos.add(1, 1, 0, queryPos))) {
                     railDirection = RailDirection.SLOPE_E;
                 }
-                if(BlockLogicRail.isRailBlockAt(this.world, this.pos.add(-1, 1, 0))) {
+                if (BlockLogicRail.isRailBlockAt(this.world, this.pos.add(-1, 1, 0, queryPos))) {
                     railDirection = RailDirection.SLOPE_W;
                 }
             }
-            if(railDirection == RailDirection.NONE) {
+            if (railDirection == RailDirection.NONE) {
                 railDirection = RailDirection.STRAIGHT_NS;
             }
             int newMeta = railDirection.meta;
-            if(this.isPoweredRail) {
+            if (this.isPoweredRail) {
                 newMeta |= this.world.getBlockData(this.pos) & MASK_POWERED;
             }
             this.world.setBlockDataNotify(this.pos, newMeta);
